

<?php

require 'config.php';
require 'Slim/Slim.php';
// Allow from any origin
if (isset($_SERVER['HTTP_ORIGIN'])) {
    header("Access-Control-Allow-Origin: {$_SERVER['HTTP_ORIGIN']}");
    header('Access-Control-Allow-Credentials: true');
    header('Access-Control-Max-Age: 86400');    // cache for 1 day
}

// Access-Control headers are received during OPTIONS requests
if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {

    if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_METHOD']))
        header("Access-Control-Allow-Methods: GET, POST, OPTIONS");

    if (isset($_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']))
        header("Access-Control-Allow-Headers:        {$_SERVER['HTTP_ACCESS_CONTROL_REQUEST_HEADERS']}");

    exit(0);
}

\Slim\Slim::registerAutoloader();
$app = new \Slim\Slim();

$app->post('/login', 'login'); /* User login */
$app->post('/signup', 'signup'); /* User Signup  */
$app->post('/updateUser', 'updateUser');
$app->post('/saveStatusPengiriman', 'saveStatusPengiriman'); 
$app->post('/getStatusPengiriman', 'getStatusPengiriman');
$app->post('/updateStatusPengiriman', 'updateStatusPengiriman'); 
$app->post('/getInvoice', 'getInvoice');

 
$app->run();

/* * *********************** USER LOGIN ************************************ */
/* ### User login ### */

function login() {

    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());

    try {

        $db = getDB();
        $userData = '';
        $sql = "SELECT * FROM vw_pos_master_user WHERE (username=:username or email=:username2) and password=:password ";
        $stmt = $db->prepare($sql);
        $stmt->bindParam("username", $data->user_name, PDO::PARAM_STR);
        $stmt->bindParam("username2", $data->user_name, PDO::PARAM_STR);
        $password = hash('sha256', $data->user_password);
        $stmt->bindParam("password", $password, PDO::PARAM_STR);
        $stmt->execute();
        $mainCount = $stmt->rowCount();
        $userData = $stmt->fetch(PDO::FETCH_OBJ);

        if (!empty($userData)) {
            $username = $userData->username;
            $userData->token = apiToken($username);
        }

        $db = null;
        if ($userData) {
            $userData = json_encode($userData);
            echo '{"userData": ' . $userData . '}';
        } else {
            echo '{"error":{"text":"Bad request wrong username and password"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

/* ### User registration ### */

function signup() {
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $email = $data->email;
    $name = $data->name;
    $username = $data->username;
    $password = $data->password;
    $id_jabatan = $data->id_jabatan;
    $nomor_ponsel = $data->nomor_ponsel;

    try {

        $username_check = preg_match('~^[A-Za-z0-9_]{3,20}$~i', $username);
        $email_check = preg_match('~^[a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.([a-zA-Z]{2,4})$~i', $email);
        $password_check = preg_match('~^[A-Za-z0-9!@#$%^&*()_]{6,20}$~i', $password);

        echo $email_check . '<br/>' . $email;

        if (strlen(trim($username)) > 0 && strlen(trim($password)) > 0 && strlen(trim($email)) > 0 && $email_check > 0 && $username_check > 0 && $password_check > 0) {
            echo 'here';
            $db = getDB();
            $userData = '';
            $sql = "SELECT user_id FROM pos_tbl_master_user WHERE username=:username or email=:email";
            $stmt = $db->prepare($sql);
            $stmt->bindParam("username", $username, PDO::PARAM_STR);
            $stmt->bindParam("email", $email, PDO::PARAM_STR);
            $stmt->execute();
            $mainCount = $stmt->rowCount();
            $created = time();
            if ($mainCount == 0) {

                /* Inserting user values */
                $sql1 = "INSERT INTO pos_tbl_master_user (username,password,email,name, nomor_ponsel, id_jabatan)VALUES(:username,:password,:email,:name, :nomor_ponsel, :id_jabatan)";
                $stmt1 = $db->prepare($sql1);
                $stmt1->bindParam("username", $username, PDO::PARAM_STR);
                $password = hash('sha256', $data->password);
                $stmt1->bindParam("password", $password, PDO::PARAM_STR);
                $stmt1->bindParam("email", $email, PDO::PARAM_STR);
                $stmt1->bindParam("name", $name, PDO::PARAM_STR);
                $stmt1->bindParam("nomor_ponsel", $nomor_ponsel, PDO::PARAM_STR);
                $stmt1->bindParam("id_jabatan", $id_jabatan, PDO::PARAM_STR);
                $stmt1->execute();

                $userData = internalUserDetails($email);
            }

            $db = null;


            if ($userData) {
                $userData = json_encode($userData);
                echo '{"userData": ' . $userData . '}';
            } else {
                echo '{"error":{"text":"Enter valid data"}}';
            }
        } else {
            echo '{"error":{"text":"Enter valid data"}}';
        }
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function updateUser(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $user_id = $data->user_id;
    $email = $data->email;
    $name = $data->name;
    $username = $data->username;
    $password = $data->password;
    $nomor_ponsel = $data->nomor_ponsel;

      /* Inserting user values */
        $db = getDB();
        $userData = '';
    $sql1 = "UPDATE pos_tbl_master_user SET username=:username, password=:password, email=:email, nomor_ponsel=:nomor_ponsel where user_id=:user_id";
    $stmt1 = $db->prepare($sql1);
    $stmt1->bindParam("user_id", $user_id, PDO::PARAM_STR);
    $stmt1->bindParam("username", $username, PDO::PARAM_STR);
    $password = hash('sha256', $data->password);
    $stmt1->bindParam("password", $password, PDO::PARAM_STR);
    $stmt1->bindParam("email", $email, PDO::PARAM_STR);
    $stmt1->bindParam("nomor_ponsel", $nomor_ponsel, PDO::PARAM_STR);
    $stmt1->execute();

    $sql = "SELECT * FROM vw_pos_master_user WHERE (username=:username or email=:email) ";
        $stmt = $db->prepare($sql);
        $stmt->bindParam("username", $data->username, PDO::PARAM_STR);
        $stmt->bindParam("email", $data->email, PDO::PARAM_STR);
        $stmt->execute();
        $userData = $stmt->fetch(PDO::FETCH_OBJ);
    if ($userData) {
        $userData = json_encode($userData);
        echo '{"userData": ' . $userData . '}';
    } else {
        echo '{"error":{"text":"Enter valid data"}}';
    }
}

/* ######## Buat Pengiriman ############### */
function getInvoice(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $TransID = $data->TransID;

    try {
            $db = getDB();
            
            $sql1 = "SELECT * FROM vwDO where NoInvoice=:TransID";
            $stmt = $db->prepare($sql1);
            $stmt->bindParam('TransID', $TransID, PDO::PARAM_STR);
            
            $stmt->execute();
            $DataDO = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($DataDO)
                echo '{"DataDO": ' . json_encode($DataDO) . '}';
            else
                echo '{"DataDO": ""}';

    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

/* ######## Buat Pengiriman ############### */
function saveStatusPengiriman(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $id_kurir = $data->id_kurir;
    $qrcode = $data->qrcode;
    $latitude = $data->latitude;
    $longitude = $data->longitude;
    $address = $data->address;
    $aktivitas = $data->aktivitas;
    $datetime_checkin = $data->datetime_checkin;

    try {
            $db = getDB();
            $sql = "INSERT INTO logistik_kurir (id_kurir ,qrcode ,latitude ,longitude,address,aktivitas,datetime_checkin) VALUES (:id_kurir ,:qrcode ,:latitude ,:longitude,:address,:aktivitas,:datetime_checkin)";
            $stmt = $db->prepare($sql);
            $stmt->bindParam('id_kurir', $id_kurir, PDO::PARAM_STR);
            $stmt->bindParam('qrcode', $qrcode, PDO::PARAM_STR);
            $stmt->bindParam('latitude', $latitude, PDO::PARAM_STR);
            $stmt->bindParam('longitude', $longitude, PDO::PARAM_STR);
            $stmt->bindParam('address', $address, PDO::PARAM_STR);
            $stmt->bindParam('aktivitas', $aktivitas, PDO::PARAM_STR);
            $stmt->bindParam('datetime_checkin', $datetime_checkin, PDO::PARAM_STR);
            $stmt->execute();
            
            $sql1 = "SELECT TOP(1) * FROM logistik_kurir where id_kurir=:id_kurir ORDER BY tanggal";
            $stmt = $db->prepare($sql1);
            $stmt->bindParam('id_kurir', $id_kurir, PDO::PARAM_STR);
            
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"dataLogistik": ' . json_encode($feedData) . '}';
            else
                echo '{"dataLogistik": ""}';

    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

function getStatusPengiriman(){

    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $id_kurir = $data->id_kurir;

    try {
        $db = getDB();
        $sql1 = "SELECT * FROM logistik_kurir where id_kurir=:id_kurir ORDER BY tanggal";
            $stmt = $db->prepare($sql1);
            $stmt->bindParam('id_kurir', $id_kurir, PDO::PARAM_STR);
            
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"dataLogistik": ' . json_encode($feedData) . '}';
            else
                echo '{"dataLogistik": ""}';
        } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}
function updateStatusPengiriman(){
    $request = \Slim\Slim::getInstance()->request();
    $data = json_decode($request->getBody());
    $id = $data->id;
    date_default_timezone_set("Asia/Bangkok");
    $created_date =  date("Y-m-d h:i:s");
    $datetime_checkout = date("Y-m-d h:i:s");
    $address_checkout = $data->address_checkout;
    $latitude_checkout = $data->latitude_checkout;
    $longitude_checkout = $data->longitude_checkout;

    try {
            $db = getDB();
           
            $sql2 = "UPDATE logistik_kurir set datetime_checkout =:datetime_checkout, address_checkout=:address_checkout, latitude_checkout=:latitude_checkout, longitude_checkout=:longitude_checkout where id=:id";
            $stmt2 = $db->prepare($sql2);
            $stmt2->bindParam('id', $id, PDO::PARAM_STR);
            $stmt2->bindParam('address_checkout', $address_checkout, PDO::PARAM_STR);
            $stmt2->bindParam('datetime_checkout', $datetime_checkout, PDO::PARAM_STR);
            $stmt2->bindParam('latitude_checkout', $latitude_checkout, PDO::PARAM_STR);
            $stmt2->bindParam('longitude_checkout', $longitude_checkout, PDO::PARAM_STR);
            $stmt2->execute();
            
            $sql1 = "SELECT * FROM logistik_kurir ORDER BY datetime_checkin";
            $stmt = $db->prepare($sql1);
            $stmt->execute();
            $feedData = $stmt->fetchAll(PDO::FETCH_OBJ);

            $db = null;

            if ($feedData)
                echo '{"dataLogistik": ' . json_encode($feedData) . '}';
            else
                echo '{"error":{"text":"Enter valid data"}}';
    } catch (PDOException $e) {
        echo '{"error":{"text":' . $e->getMessage() . '}}';
    }
}

